local OW = unpack(select(2, ...))  -->Engine
local E, C, F, L = unpack(Quafe)  -->Engine, Config, Function, Locale

----------------------------------------------------------------
--> API and Variable
----------------------------------------------------------------

local _G = getfenv(0)
local min = math.min
local max = math.max
local format = string.format
local floor = math.floor
local sqrt = math.sqrt
local sin = math.sin
local asin = math.asin
local cos = math.cos
local acos = math.acos
local tan = math.tan
local atan = math.atan
local rad = math.rad
local modf = math.modf
local GetTime = _G.GetTime

----------------------------------------------------------------
--> Left
----------------------------------------------------------------

local TAN_4 = format("%.2f",tan(rad(4)))
--[[
local HpBar_Num = {
    [1] = {21,18},
    [2] = {22,23},
    [3] = {22,23},
    [4] = {22,23},
    [5] = {22,23},
    [6] = {22,23},
}

local HB_tx1 = 1+40*6
local HB_tx2 = 39+40*6
--]]

local NUM_40 = {
    [0] = {20,   2/1024, 42/1024},
    [1] = {20,  46/1024, 86/1024},
    [2] = {20,  90/1024,130/1024},
    [3] = {20, 134/1024,174/1024},
    [4] = {20, 178/1024,218/1024},
    [5] = {20, 222/1024,262/1024},
    [6] = {20, 266/1024,306/1024},
    [7] = {20, 310/1024,350/1024},
    [8] = {20, 354/1024,394/1024},
    [9] = {20, 398/1024,438/1024},
    ["K"] = {20, 442/1024,482/1024},
    ["M"] = {20, 486/1024,526/1024},
    ["G"] = {20, 530/1024,570/1024},
    ["N"] = {20, 1023/1024,1024/1024},
}

local NUM_20 = {
    [0] = {12,   2/1024, 26/1024},
    [1] = {12,  30/1024, 54/1024},
    [2] = {12,  58/1024, 82/1024},
    [3] = {12,  86/1024,110/1024},
    [4] = {12, 114/1024,138/1024},
    [5] = {12, 142/1024,166/1024},
    [6] = {12, 170/1024,194/1024},
    [7] = {12, 198/1024,222/1024},
    [8] = {12, 226/1024,250/1024},
    [9] = {12, 254/1024,278/1024},
    ["K"] = {12, 282/1024,306/1024},
    ["M"] = {12, 310/1024,334/1024},
    ["G"] = {12, 338/1024,362/1024},
    ["/"] = {12, 366/1024,390/1024},
    ["N"] = {12, 1023/1024,1024/1024},
}

local Unit_Init = function(frame)
	F.init_Unit(frame, frame.Unit, true)
	frame: SetScript("OnEnter", F.UnitFrame_OnEnter)
	frame: SetScript("OnLeave", F.UnitFrame_OnLeave)
end

local function HpBar_Template(frame)
    local HpBar = CreateFrame("Frame", nil, frame)
    HpBar: SetSize(226,45)
    HpBar: SetPoint("BOTTOMLEFT")

    local Bar = HpBar: CreateTexture(nil, "ARTWORK")
    Bar: SetVertexColor(243/255, 244/255, 246/255)
    Bar: SetAlpha(1)
    Bar: SetTexture(OW.Path("Bar1_2"))
    Bar: SetPoint("CENTER")
    Bar: SetSize(226,45)
    Bar: SetTexCoord(1/256,227/256, 0/4096,45/4096)

    local Bg = HpBar: CreateTexture(nil, "BORDER")
    Bg: SetVertexColor(243/255, 244/255, 246/255)
    Bg: SetAlpha(0.4)
    Bg: SetTexture(OW.Path("Bar1_1"))
    Bg: SetPoint("CENTER")
    Bg: SetSize(226,45)
    Bg: SetTexCoord(1/256,227/256, 0/128,45/128)

    local Sd = HpBar: CreateTexture(nil, "BACKGROUND")
    Sd: SetVertexColor(F.Color(C.Color.Main0))
    Sd: SetAlpha(0.4)
    Sd: SetTexture(OW.Path("Bar1_1"))
    Sd: SetPoint("CENTER")
    Sd: SetSize(226,45)
    Sd: SetTexCoord(1/256,227/256, 45/128,90/128)

    HpBar.Bar = Bar
    HpBar.Bg = Bg
    HpBar.Sd = Sd

    return HpBar
end

local function HpBar_Update(frame, d)
    if not d then d = 0 end
    if d < 0 then d = 0 end
    if d > 1 then d = 1 end
    if not frame.OldPer or frame.OldPer ~= d then
        local y = 45*floor(90*(1-d)+0.5)
        frame.Bar: SetTexCoord(1/256,227/256, y/4096,(y+45)/4096)
        frame.OldPer = d
    end
end

local function Absorb_Template(frame)
    local AbsorbBar = CreateFrame("Frame", nil, frame)
    AbsorbBar: SetSize(234,53)
    AbsorbBar: SetFrameLevel(frame:GetFrameLevel()+3)
    
    local Left = AbsorbBar: CreateTexture(nil, "ARTWORK")
    Left: SetTexture(OW.Path("Bar1_3"))
    Left: SetSize(234,53)
    Left: SetPoint("LEFT")
    Left: SetTexCoord(1/512,469/512, 1/512,107/512)
    Left: SetVertexColor(243/255, 244/255, 246/255)

    local Right = AbsorbBar: CreateTexture(nil, "ARTWORK")
    Right: SetTexture(OW.Path("Bar1_3"))
    Right: SetSize(234,53)
    Right: SetPoint("LEFT")
    Right: SetTexCoord(1/512,469/512, 109/512,215/512)
    Right: SetVertexColor(243/255, 244/255, 246/255)
    Right: Hide()

    local Bar1 = AbsorbBar: CreateTexture(nil, "ARTWORK")
    Bar1: SetTexture(OW.Path("Bar1_3"))
    Bar1: SetSize(234,53)
    Bar1: SetPoint("LEFT")
    Bar1: SetTexCoord(1/512,469/512, 217/512,323/512)
    Bar1: SetVertexColor(243/255, 244/255, 246/255)

    local Bar2 = AbsorbBar: CreateTexture(nil, "ARTWORK")
    Bar2: SetTexture(OW.Path("Bar1_3"))
    Bar2: SetSize(234,53)
    Bar2: SetPoint("LEFT")
    Bar2: SetTexCoord(1/512,469/512, 325/512,431/512)
    Bar2: SetVertexColor(243/255, 244/255, 246/255)

    local Nonius = AbsorbBar: CreateTexture(nil, "ARTWORK")
    Nonius: SetTexture(OW.Path("Bar1_3"))
    Nonius: SetSize(20,44)
    Nonius: SetPoint("LEFT", AbsorbBar, "LEFT", 0,-7)
    --Nonius: SetPoint("LEFT", AbsorbBar, "LEFT", 210,-6+211*TAN_4)
    Nonius: SetTexCoord(471/512,511/512, 1/512,89/512)
    Nonius: SetVertexColor(243/255, 244/255, 246/255)

    local NoniusSd = AbsorbBar: CreateTexture(nil, "BACKGROUND")
    NoniusSd: SetTexture(OW.Path("Bar1_3"))
    NoniusSd: SetSize(20,44)
    NoniusSd: SetPoint("CENTER", Nonius, "CENTER")
    NoniusSd: SetTexCoord(471/512,511/512, 91/512,179/512)
    NoniusSd: SetVertexColor(F.Color(C.Color.Main0))
    NoniusSd: SetAlpha(0.4)
    --Nonius: Hide()

    AbsorbBar.Nonius = Nonius
    AbsorbBar.Bar1 = Bar1
    AbsorbBar.Bar2 = Bar2

    return AbsorbBar
end

local function Absorb_Update(frame, d)
    if not d then d = 0 end
    if d < 0 then d = 0 end
    if d > 1 then d = 1 end
    if not frame.OldPer or frame.OldPer ~= d then
        if d == 0 then
            frame: SetAlpha(0)
        else
            local x = 211*d
            frame.Nonius:SetPoint("LEFT", frame, "LEFT", x,-7+TAN_4*x)
            frame.Bar1: SetWidth(12+x)
            frame.Bar1: SetTexCoord(1/512,(25+x*2)/512, 217/512,323/512)
            frame.Bar2: SetWidth(5+x)
            frame.Bar2: SetTexCoord(1/512,(11+x*2)/512, 325/512,431/512)
            frame: SetAlpha(1)
        end
        frame.OldPer = d
    end
end

local function PpBarFlash_Template(frame)
    local Flash = CreateFrame("Frame", nil, frame, "OW_PlayerPowerFlashTemplate")
    Flash: SetSize(38,38)

    local inner1 = Flash: CreateTexture(nil, "OVERLAY")
    inner1: SetTexture(OW.Path("Bar2_2"))
    inner1: SetSize(38,38)
    inner1: SetTexCoord(79/256,155/256, 79/256,155/256)
    inner1: SetPoint("CENTER")
    inner1: SetVertexColor(31/255, 174/255, 255/255)
    inner1: SetAlpha(0.4)

    local inner2 = Flash: CreateTexture(nil, "BACKGROUND")
    inner2: SetTexture(OW.Path("Bar2_2"))
    inner2: SetSize(38,38)
    inner2: SetTexCoord(1/256,77/256, 79/256,155/256)
    inner2: SetPoint("CENTER")
    inner2: SetVertexColor(243/255, 244/255, 246/255)
    inner2: SetAlpha(0.8)

    local outter1 = Flash: CreateTexture(nil, "ARTWORK")
    outter1: SetTexture(OW.Path("Bar2_2"))
    outter1: SetSize(38,38)
    outter1: SetTexCoord(79/256,155/256, 1/256,77/256)
    outter1: SetPoint("CENTER")
    outter1: SetVertexColor(31/255, 174/255, 255/255)
    outter1: SetAlpha(0)

    local outter2 = Flash: CreateTexture(nil, "BORDER")
    outter2: SetTexture(OW.Path("Bar2_2"))
    outter2: SetSize(38,38)
    outter2: SetTexCoord(1/256,77/256, 1/256,77/256)
    outter2: SetPoint("CENTER")
    outter2: SetVertexColor(31/255, 174/255, 255/255)
    outter2: SetAlpha(0.4)

    return Flash
end

local function PpBarMana_Template(frame)
    local Mana = CreateFrame("Frame", nil, frame)
    Mana: SetSize(12,10)

    local Nonius = Mana: CreateTexture(nil, "ARTWORK")
    Nonius: SetTexture(OW.Path("Bar2_1"))
    Nonius: SetSize(12,10)
    Nonius: SetPoint("CENTER", Mana, "CENTER")
    --Nonius: SetPoint("LEFT", AbsorbBar, "LEFT", 210,-6+211*TAN_4)
    Nonius: SetTexCoord(476/512,500/512, 2/128,20/128)
    Nonius: SetVertexColor(243/255, 244/255, 246/255)

    local NoniusSd = Mana: CreateTexture(nil, "BACKGROUND")
    NoniusSd: SetTexture(OW.Path("Bar2_1"))
    NoniusSd: SetSize(12,10)
    NoniusSd: SetPoint("CENTER", Mana, "CENTER")
    NoniusSd: SetTexCoord(476/512,500/512, 23/128,43/128)
    NoniusSd: SetVertexColor(F.Color(C.Color.Main0))
    NoniusSd: SetAlpha(0.4)

    return Mana
end

local function PpBar_Template(frame)
    local PpBar = CreateFrame("Frame", nil, frame)
    PpBar: SetSize(197,22)
    PpBar: SetPoint("BOTTOMLEFT")

    local Bar = PpBar: CreateTexture(nil, "ARTWORK")
    Bar: SetVertexColor(31/255, 174/255, 255/255)
    Bar: SetAlpha(1)
    Bar: SetTexture(OW.Path("Bar2_1"))
    Bar: SetPoint("LEFT")
    Bar: SetSize(197,22)
    Bar: SetTexCoord(2/512,396/512, 2/128,46/128)

    local Bg = PpBar: CreateTexture(nil, "BORDER")
    Bg: SetVertexColor(243/255, 244/255, 246/255)
    Bg: SetAlpha(0.4)
    Bg: SetTexture(OW.Path("Bar2_1"))
    Bg: SetPoint("CENTER")
    Bg: SetSize(197,22)
    Bg: SetTexCoord(2/512,396/512, 2/128,46/128)

    local Sd = PpBar: CreateTexture(nil, "BACKGROUND")
    Sd: SetVertexColor(F.Color(C.Color.Main0))
    Sd: SetAlpha(0.4)
    Sd: SetTexture(OW.Path("Bar2_1"))
    Sd: SetPoint("CENTER")
    Sd: SetSize(197,22)
    Sd: SetTexCoord(2/512,396/512, 50/128,94/128)

    local Icon = PpBar: CreateTexture(nil, "ARTWORK")
    Icon: SetVertexColor(243/255, 244/255, 246/255)
    Icon: SetAlpha(1)
    Icon: SetTexture(OW.Path("Bar2_1"))
    Icon: SetPoint("BOTTOMRIGHT", PpBar, "BOTTOMLEFT", -8,-8)
    Icon: SetSize(17,20)
    Icon: SetTexCoord(400/512,434/512, 2/128,42/128)

    local IconSd = PpBar: CreateTexture(nil, "BACKGROUND")
    IconSd: SetVertexColor(F.Color(C.Color.Main0))
    IconSd: SetAlpha(0.4)
    IconSd: SetTexture(OW.Path("Bar2_1"))
    IconSd: SetPoint("CENTER", Icon, "CENTER")
    IconSd: SetSize(17,20)
    IconSd: SetTexCoord(438/512,472/512, 2/128,42/128)

    local Flash = PpBarFlash_Template(PpBar)
    Flash: SetPoint("CENTER", PpBar, "CENTER", -96,-96*TAN_4)
    Flash: Show()

    local Mana = PpBarMana_Template(PpBar)
    Mana: SetPoint("CENTER", PpBar, "CENTER", -96,-14-96*TAN_4)
    Mana: SetAlpha(0)

    PpBar.Bar = Bar
    PpBar.Bg = Bg
    PpBar.Sd = Sd
    PpBar.Icon = Icon
    PpBar.Flash = Flash
    PpBar.Mana = Mana

    return PpBar
end

local function PpBar_Update(frame, d)
    if not d then d = 0 end
    if d < 0 then d = 0 end
    if d > 1 then d = 1 end
    if not frame.OldPer or frame.OldPer ~= d then
        local x = max(197*d, 0.0001)
        frame.Bar: SetSize(x,22)
        frame.Bar: SetTexCoord(2/512,(2+2*x)/512, 2/128,46/128)
        frame.Flash: SetPoint("CENTER", frame, "CENTER", (-96+192*d),(-96+192*d)*TAN_4)
        frame.OldPer = d
    end
end

local function PpBar_ManaUpdate(frame, d)
    if not d then d = 0 end
    if d < 0 then d = 0 end
    if d > 1 then d = 1 end
    if not frame.Mana.OldPer or frame.Mana.OldPer ~= d then
        if d == 0 then
            frame.Mana: SetAlpha(0)
        else
            local x = 192*d
            frame.Mana: SetPoint("CENTER", frame, "CENTER", (-96+x),-14+(-96+x)*TAN_4)
            frame.Mana: SetAlpha(1)
        end
        frame.Mana.OldPer = d
    end
end

local function LeftNum_Template(frame)
    local Nums = CreateFrame("Frame", nil, frame)
    Nums: SetSize(8,8)
    
    local Num40 = {}
    for i = 1,5 do
        Num40[i] = Nums: CreateTexture(nil, "ARTWORK")
        Num40[i]: SetTexture(OW.Path("Num1_1"))
        Num40[i]: SetVertexColor(243/255, 244/255, 246/255)
        Num40[i]: SetSize(NUM_40[0][1],32)
        Num40[i]: SetTexCoord(NUM_40[0][2],NUM_40[0][3], 2/256,66/256)
        if i == 1 then
            Num40[i]: SetPoint("BOTTOMLEFT", Nums, "BOTTOMLEFT", 0,0)
        else
            Num40[i]: SetPoint("BOTTOMLEFT", Num40[i-1], "BOTTOMLEFT", (NUM_40[0][1]-5),(NUM_40[0][1]-5)*TAN_4)
        end
    end

    local Num40Sd = {}
    for i = 1,5 do
        Num40Sd[i] = Nums: CreateTexture(nil, "BACKGROUND")
        Num40Sd[i]: SetTexture(OW.Path("Num1_1"))
        Num40Sd[i]: SetVertexColor(F.Color(C.Color.Main0))
        Num40Sd[i]: SetAlpha(0.4)
        Num40Sd[i]: SetSize(NUM_40[0][1],32)
        Num40Sd[i]: SetTexCoord(NUM_40[0][2],NUM_40[0][3], 70/256,134/256)
        Num40Sd[i]: SetPoint("CENTER", Num40[i], "CENTER")
    end

    local Num20 = {}
    for i = 1,6 do
        Num20[i] = Nums: CreateTexture(nil, "ARTWORK")
        Num20[i]: SetTexture(OW.Path("Num1_1"))
        Num20[i]: SetVertexColor(243/255, 244/255, 246/255)
        Num20[i]: SetSize(NUM_20[0][1],19)
        Num20[i]: SetTexCoord(NUM_20[0][2],NUM_20[0][3], 138/256,176/256)
        if i == 1 then
            Num20[i]: SetPoint("BOTTOMLEFT", Num40[5], "BOTTOMLEFT", NUM_40[0][1]+NUM_20[0][1],(NUM_40[0][1]+NUM_20[0][1])*TAN_4)
        elseif i == 6 then
            Num20[i]: SetSize(NUM_20["/"][1],19)
            Num20[i]: SetTexCoord(NUM_20["/"][2],NUM_20["/"][3], 138/256,176/256)
            --Num20[i]: SetPoint("BOTTOMLEFT", Num20[i-1], "BOTTOMLEFT", (NUM_20[0][1]-3),(NUM_20[0][1]-3)*TAN_4)
            Num20[i]: SetPoint("BOTTOMLEFT", Num40[5], "BOTTOMLEFT", (NUM_40[0][1]-6),(NUM_40[0][1]-6)*TAN_4)
        else
            Num20[i]: SetPoint("BOTTOMLEFT", Num20[i-1], "BOTTOMLEFT", (NUM_20[0][1]-4),(NUM_20[0][1]-4)*TAN_4)
        end
    end

    local Num20Sd = {}
    for i = 1,6 do
        Num20Sd[i] = Nums: CreateTexture(nil, "BACKGROUND")
        Num20Sd[i]: SetTexture(OW.Path("Num1_1"))
        Num20Sd[i]: SetVertexColor(F.Color(C.Color.Main0))
        Num20Sd[i]: SetAlpha(0.4)
        Num20Sd[i]: SetSize(NUM_20[0][1],19)
        Num20Sd[i]: SetTexCoord(NUM_20[0][2],NUM_20[0][3], 180/256,218/256)
        Num20Sd[i]: SetPoint("CENTER", Num20[i], "CENTER")

        if i == 6 then
            Num20Sd[i]: SetSize(NUM_20["/"][1],19)
            Num20Sd[i]: SetTexCoord(NUM_20["/"][2],NUM_20["/"][3], 180/256,218/256)
        end
    end

    Nums.Num40 = Num40
    Nums.Num40Sd = Num40Sd
    Nums.Num20 = Num20
    Nums.Num20Sd = Num20Sd

    return Nums
end

local function LeftNum_HpPos(frame,n)
    frame.Num40[1]: SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT", 6+(NUM_40[0][1]-6)*n,6+(NUM_40[0][1]-6)*n*TAN_4)
end

local function LeftNum_PpPos(frame,n)
    frame.Num20[1]: SetPoint("BOTTOMLEFT", frame.Num40[5], "BOTTOMLEFT", NUM_40[0][1]+4+(NUM_20[0][1]-4)*n,(NUM_40[0][1]+4+(NUM_20[0][1]-4)*n)*TAN_4)
end

local function LeftNum_HpUpdate(frame, d)
    if not frame.OldHpValue or frame.OldHpValue ~= d then
        local d0,d1,d2,d3,d4,d5
        local pos = 0
        if d >= 1e10 then
            d0 = d/1e9
            d5 = "G"
        elseif d >= 1e7 then
            d0 = d/1e6
            d5 = "M"
        elseif d >= 1e4 then
            d0 = d/1e3
            d5 = "K"
        else
            d0 = d
            d5 = "N"
        end

        if d5 == "N" then
            d1 = 0
            d2 = floor(d0/1000)
            d3 = floor((d0-floor(d0/1000)*1000)/100)
            d4 = floor((d0-floor(d0/100)*100)/10)
            d5 = floor((d0-floor(d0/10)*10)/1)
        else
            d1 = floor(d0/1000)
            d2 = floor((d0-floor(d0/1000)*1000)/100)
            d3 = floor((d0-floor(d0/100)*100)/10)
            d4 = floor((d0-floor(d0/10)*10)/1)
        end

        if d1 == 0 then
            d1 = "N"
            if d2 == 0 then
                d2 = "N"
                if d3 == 0 then
                    d3 = "N"
                    pos = -3
                else
                    pos = -2
                end
            else
                pos = -1
            end
        end

        frame.Num40[1]: SetTexCoord(NUM_40[d1][2],NUM_40[d1][3], 2/256,66/256)
        frame.Num40[2]: SetTexCoord(NUM_40[d2][2],NUM_40[d2][3], 2/256,66/256)
        frame.Num40[3]: SetTexCoord(NUM_40[d3][2],NUM_40[d3][3], 2/256,66/256)
        frame.Num40[4]: SetTexCoord(NUM_40[d4][2],NUM_40[d4][3], 2/256,66/256)
        frame.Num40[5]: SetTexCoord(NUM_40[d5][2],NUM_40[d5][3], 2/256,66/256)

        frame.Num40Sd[1]: SetTexCoord(NUM_40[d1][2],NUM_40[d1][3], 70/256,134/256)
        frame.Num40Sd[2]: SetTexCoord(NUM_40[d2][2],NUM_40[d2][3], 70/256,134/256)
        frame.Num40Sd[3]: SetTexCoord(NUM_40[d3][2],NUM_40[d3][3], 70/256,134/256)
        frame.Num40Sd[4]: SetTexCoord(NUM_40[d4][2],NUM_40[d4][3], 70/256,134/256)
        frame.Num40Sd[5]: SetTexCoord(NUM_40[d5][2],NUM_40[d5][3], 70/256,134/256)

        if not frame.OldHpPos or frame.OldHpPos ~= pos then
            LeftNum_HpPos(frame,pos)
            frame.OldHpPos = pos
        end

        --[[
        string.sub()
        for w in gmatch(tostring(count), "(%d)") do
			insert(d, w)
		end
        --]]

        frame.OldHpValue = d
    end
end

local function LeftNum_PpUpdate(frame, d)
    if not frame.OldPpValue or frame.OldPpValue ~= d then
        local d0,d1,d2,d3,d4,d5
        local pos = 0
        if d >= 1e10 then
            d0 = d/1e9
            d5 = "G"
        elseif d >= 1e7 then
            d0 = d/1e6
            d5 = "M"
        elseif d >= 1e4 then
            d0 = d/1e3
            d5 = "K"
        else
            d0 = d
            d5 = "N"
        end

        if d5 == "N" then
            d1 = 0
            d2 = floor(d0/1000)
            d3 = floor((d0-floor(d0/1000)*1000)/100)
            d4 = floor((d0-floor(d0/100)*100)/10)
            d5 = floor((d0-floor(d0/10)*10)/1)
        else
            d1 = floor(d0/1000)
            d2 = floor((d0-floor(d0/1000)*1000)/100)
            d3 = floor((d0-floor(d0/100)*100)/10)
            d4 = floor((d0-floor(d0/10)*10)/1)
        end

        if d1 == 0 then
            d1 = "N"
            if d2 == 0 then
                d2 = "N"
                if d3 == 0 then
                    d3 = "N"
                    pos = -3
                else
                    pos = -2
                end
            else
                pos = -1
            end
        end

        frame.Num20[1]: SetTexCoord(NUM_20[d1][2],NUM_20[d1][3], 138/256,176/256)
        frame.Num20[2]: SetTexCoord(NUM_20[d2][2],NUM_20[d2][3], 138/256,176/256)
        frame.Num20[3]: SetTexCoord(NUM_20[d3][2],NUM_20[d3][3], 138/256,176/256)
        frame.Num20[4]: SetTexCoord(NUM_20[d4][2],NUM_20[d4][3], 138/256,176/256)
        frame.Num20[5]: SetTexCoord(NUM_20[d5][2],NUM_20[d5][3], 138/256,176/256)

        frame.Num20Sd[1]: SetTexCoord(NUM_20[d1][2],NUM_20[d1][3], 180/256,218/256)
        frame.Num20Sd[2]: SetTexCoord(NUM_20[d2][2],NUM_20[d2][3], 180/256,218/256)
        frame.Num20Sd[3]: SetTexCoord(NUM_20[d3][2],NUM_20[d3][3], 180/256,218/256)
        frame.Num20Sd[4]: SetTexCoord(NUM_20[d4][2],NUM_20[d4][3], 180/256,218/256)
        frame.Num20Sd[5]: SetTexCoord(NUM_20[d5][2],NUM_20[d5][3], 180/256,218/256)

        if not frame.OldPpPos or frame.OldPpPos ~= pos then
            LeftNum_PpPos(frame,pos)
            frame.OldPpPos = pos
        end

        frame.OldPpValue = d
    end
end

local function Portrait_Artwork(frame)
    local Border = CreateFrame("Frame", nil, frame)
    Border: SetAllPoints(frame)

    local Back = CreateFrame("Frame", nil, Border)
    Back: SetSize(156,170)
    Back: SetPoint("CENTER")
    Back: SetFrameLevel(frame:GetFrameLevel())
    
    local Bg1 = Back: CreateTexture(nil, "BACKGROUND")
    Bg1: SetTexture(OW.Path("Player_Bd1"))
    Bg1: SetSize(156,170)
    Bg1: SetTexCoord(1/1024,313/1024, 1/1024,341/1024)
    Bg1: SetPoint("CENTER")
    Bg1: SetVertexColor(31/255, 174/255, 255/255)
    Bg1: SetAlpha(0.2)

    local Bd1 = Back: CreateTexture(nil, "BORDER")
    Bd1: SetTexture(OW.Path("Player_Bd1"))
    Bd1: SetSize(156,170)
    Bd1: SetTexCoord(316/1024,628/1024, 1/1024,341/1024)
    Bd1: SetPoint("CENTER")
    Bd1: SetVertexColor(31/255, 174/255, 255/255)
    Bd1: SetAlpha(0.5)

    local Bd2 = Back: CreateTexture(nil, "ARTWORK")
    Bd2: SetTexture(OW.Path("Player_Bd1"))
    Bd2: SetSize(156,170)
    Bd2: SetTexCoord(631/1024,943/1024, 1/1024,341/1024)
    Bd2: SetPoint("CENTER")
    Bd2: SetVertexColor(31/255, 174/255, 255/255)
    Bd2: SetAlpha(0.4)

    local Flash = CreateFrame("Frame", nil, Border, "OW_PlayerPortraitFlashTemplate")
	Flash: SetSize(170,170)
	Flash: SetFrameLevel(frame:GetFrameLevel()+1)
	Flash: SetPoint("CENTER", Border, "CENTER")

    local FlashBd = Flash: CreateTexture(nil, "BORDER")
    FlashBd: SetTexture(OW.Path("Player_Bd1"))
    FlashBd: SetSize(156,170)
    FlashBd: SetTexCoord(316/1024,628/1024, 1/1024,341/1024)
    FlashBd: SetPoint("CENTER")
    FlashBd: SetVertexColor(31/255, 174/255, 255/255)
    FlashBd: SetAlpha(0.75)

    Flash: Show()

    local Front = CreateFrame("Frame", nil, Border)
    Front: SetSize(156,170)
    Front: SetPoint("CENTER")
    Front: SetFrameLevel(frame:GetFrameLevel()+2)

    local Bd3 = Front: CreateTexture(nil, "ARTWORK")
    Bd3: SetTexture(OW.Path("Player_Bd1"))
    Bd3: SetSize(156,170)
    Bd3: SetTexCoord(1/1024,313/1024, 682/1024,1023/1024)
    Bd3: SetPoint("CENTER")
    Bd3: SetAlpha(1)

    local Bd4 = Back: CreateTexture(nil, "ARTWORK")
    Bd4: SetTexture(OW.Path("Player_Bd1"))
    Bd4: SetSize(156,170)
    Bd4: SetTexCoord(316/1024,628/1024, 682/1024,1023/1024)
    Bd4: SetPoint("CENTER")
    Bd4: SetAlpha(1)

    local Bd5 = Front: CreateTexture(nil, "ARTWORK")
    Bd5: SetTexture(OW.Path("Player_Bd1"))
    Bd5: SetSize(156,170)
    Bd5: SetTexCoord(316/1024,628/1024, 344/1024,684/1024)
    Bd5: SetPoint("CENTER")
    Bd5: SetAlpha(1)

    local Bd6 = Back: CreateTexture(nil, "ARTWORK")
    Bd6: SetTexture(OW.Path("Player_Bd1"))
    Bd6: SetSize(156,170)
    Bd6: SetTexCoord(631/1024,943/1024, 344/1024,684/1024)
    Bd6: SetPoint("CENTER")
    Bd6: SetAlpha(1)

    Border.Bg1 = Bg1
    Border.Bd1 = Bd1
    Border.Bd2 = Bd2
    Border.BdF = FlashBd

    return Border
end

local Portrait_ColorUpdate = function(frame, color)
    frame.Bg1: SetVertexColor(F.Color(color))
    frame.Bd1: SetVertexColor(F.Color(color))
    frame.Bd2: SetVertexColor(F.Color(color))
    frame.BdF: SetVertexColor(F.Color(color))
end

local Portrait_StatusUpdate = function(frame, event)
    if event == "PLAYER_ENTERING_WORLD" or event == "PLAYER_REGEN_DISABLED" or event == "PLAYER_REGEN_ENABLED" or event == "PLAYER_UPDATE_RESTING" then
        if UnitAffectingCombat("player") then
            Portrait_ColorUpdate(frame.PortraitBorder, {r=249/255, g=124/255, b=134/255})
        elseif IsResting() then
            Portrait_ColorUpdate(frame.PortraitBorder, {r=220/255, g=182/255, b=64/255})
        else
            Portrait_ColorUpdate(frame.PortraitBorder, {r=31/255, g=174/255, b=255/255})
        end
    end
end

local RaceModelList = {
    [1]  = {
        [2] = {1, 0.9, 0,0,-0.06, 0},
        [3] = {1, 0.95, 0,0.01,0, 0},
    }, --Human 人类
    [2]  = {
        [2] = {1, 0.75, 0.1,-0.01,-0.17, 10},
        [3] = {1, 0.9, 0.1,-0.02,-0.04, 0},
    }, --Orc 兽人
    [3]  = {
        [2] = {1, 0.8, 0.1,-0.02,-0.06, 0},
        [3] = {1, 0.8, 0.1,-0.035,-0.06, 0},
    }, --Dwarf 矮人
    [4]  = {
        [2] = {1, 0.85, 0.1,-0.02,-0.08, 5},
        [3] = {1, 0.9, 0.1,-0.05,-0.02, 0},
    }, --NightElf 暗夜精灵
    [5]  = {
        [2] = {1, 0.8, 0.1,-0.04,-0.10, 5},
        [3] = {1, 0.85, 0.1,-0.01,-0.02, 5},
    }, --Scourge 被遗忘者
    [6]  = {
        [2] = {1, 0.6, 0,0.00,-0.30, 10},
        [3] = {1, 0.8, 0,0.03,-0.15, 0},
    }, --Tauren 牛头人
    [7]  = {
        [2] = {1, 0.80, 0.1,-0.02,-0.08, 0},
        [3] = {1, 0.80, 0.1,-0.05,-0.04, 0},
    }, --Gnome 侏儒
    [8]  = {
        [2] = {1, 0.9, 0.1,-0.02,-0.04, -10},
        [3] = {1, 0.9, 0.1,-0.02,-0.04, 0},
    }, --Troll 巨魔
    [9]  = {
        [2] = {1, 0.8, 0.1,-0.08,-0.06, 0},
        [3] = {1, 0.85, 0.1,-0.02,-0.04, 0},
    }, --Goblin 哥布林
    [10] = {
        [2] = {1, 0.9, 0.1,-0.03,-0.06, 5},
        [3] = {1, 0.9, 0.1,-0.07,-0.02, -5},
    }, --BloodElf 血精灵
    [11] = {
        [2] = {1, 0.9, 0,-0.04,-0.06, 5},
        [3] = {1, 1, 0,0.02,0.02, -10}, --1022598
    }, --Draenei 德莱尼
    --[12] = {}, --FelOrc 邪兽人
    --[13] = {}, --Naga_ 娜迦
    --[14] = {}, --Broken 破碎者
    --[15] = {}, --Skeleton 骷髅
    --[16] = {}, --Vrykul 维库
    --[17] = {}, --Tuskarr 海象人
    --[18] = {}, --ForestTroll 森林巨魔
    --[19] = {}, --Taunka 牦牛人
    --[20] = {}, --NorthrendSkeleton 诺森德骷髅
    --[21] = {}, --IceTroll 冰霜巨魔
    [22] = {
        [2] = {1, 0.95, 0,0.02,-0.10, 0}, --307454
        [3] = {1, 0.98, 0,0.08,-0.04, -5}, --307453 1000764
    }, --Worgen 狼人
    --[23] = {}, --Gilnean 吉尔尼斯人
    [24] = {
        [2] = {1, 0.95, 0.0,0.02,-0.02, -5},
        [3] = {1, 0.90, 0.0,0.00,-0.02, -5},
    }, --Pandaren 熊猫人中立
    --[25] = {}, --Pandaren 熊猫人联盟
    --[26] = {}, --Pandaren 熊猫人部落
    [27] = {
        [2] = {1, 0.96, 0,0.05,-0.02, -5},
        [3] = {1, 0.95, 0.0,0.01,-0.00, 0},
    }, --Nightborne 夜之子
    --[28] = {}, --HighmountainTauren 至高岭牛头人
    --[29] = {}, --Void Elf 虚空精灵
    --[30] = {}, --LightforgedDraenei 光铸德莱尼
    [31] = {
        [2] = {1, 1, 0,-0.01,-0.00, 0},
        [3] = {1, 0.95, 0,0.05,-0.02, -5},
    }, --ZandalariTroll 赞达拉巨魔
    [32] = {
        [2] = {1, 0.95, 0,0.02,-0.04, 0},
        [3] = {1, 0.98, 0,0.01,-0.00, -10},
    }, --KulTiran 库尔提拉斯人
    --[33] = {}, --ThinHuman 瘦人
    --[34] = {}, --DarkIronDwarf 黑铁矮人
    [35] = {
        [2] = {1, 0.9, 0,0,-0.04, 0},
        [3] = {1, 0.9, 0,0,-0.04, 0},
    }, --Vulpera 狐人
    --[36] = {}, --MagharOrc 玛格汉兽人
    --[37] = {}, --Mechagnome 机械侏儒
}

RaceModelList[25] = RaceModelList[24] --Pandaren 熊猫人联盟
RaceModelList[26] = RaceModelList[24] --Pandaren 熊猫人部落
RaceModelList[28] = RaceModelList[6] --HighmountainTauren 至高岭牛头人
RaceModelList[29] = RaceModelList[10] --Void Elf 虚空精灵
RaceModelList[30] = RaceModelList[11] --LightforgedDraenei 光铸德莱尼
RaceModelList[34] = RaceModelList[3] --DarkIronDwarf 黑铁矮人
RaceModelList[36] = RaceModelList[2] --MagharOrc 玛格汉兽人
RaceModelList[37] = RaceModelList[7] --Mechagnome 机械侏儒


local RaceModelFileList = {
    [1011653] = RaceModelList[1][2], -- 人类男 狼人男人类形态
    [1000764] = RaceModelList[1][3], -- 人类女 狼人女人类形态
}

local function Portrait_UpdateScale(frame)
    --local UI_Scale = UIParent:GetScale()
    local UI_Scale = GetCVar("uiScale")
	frame: SetModelScale(0.711/(Quafe_DB.Profile[Quafe_DBP.Profile].OW_PlayerFrame.Scale*UI_Scale))
end

local function Portrait_Model(frame)
    local Model = CreateFrame("PlayerModel", nil, frame)
    --Model: SetSize(74,90)
    Model: SetSize(80,110)
    Model: SetPoint("BOTTOM", frame, "CENTER", 0,-36)
    Model: SetFrameLevel(frame:GetFrameLevel()+1)
    Model: SetUnit("player")
    --Model: StopAnimKit()
    --Model: SetAnimation(804, 1)

    Model: RegisterEvent("PLAYER_ENTERING_WORLD")
    Model: RegisterEvent("UI_SCALE_CHANGED")
    Model: RegisterUnitEvent("UNIT_MODEL_CHANGED", "player")
	Model: RegisterUnitEvent("UNIT_PORTRAIT_UPDATE", "player")
    Model: SetScript("OnEvent", function(self,event)
        local RaceID = select(3,UnitRace("player"))
        local Gender = UnitSex("player") --1 = Neutrum / Unknown, 2 = Male, 3 = Female
        if RaceID and Gender then
            --self: ClearModel()
            --self: SetModel("Character\\NightElf\\Female\\NightElfFemale.mdx")
            --self: SetCustomRace(RaceID, Gender) Gender: 0 Male, 1 Female
            --RaceID = 2
            --Gender = 3
            self: SetCustomRace(RaceID, Gender-2)
            --self: Dress()
            self: SetAnimation(0, 0)
            Portrait_UpdateScale(self)

            if RaceModelList[RaceID] and RaceModelList[RaceID][Gender] then
                self: SetCamDistanceScale(RaceModelList[RaceID][Gender][1])
                self: SetPortraitZoom(RaceModelList[RaceID][Gender][2])
                self: SetPosition(RaceModelList[RaceID][Gender][3],RaceModelList[RaceID][Gender][4],RaceModelList[RaceID][Gender][5])
                self: SetRotation(rad(RaceModelList[RaceID][Gender][6]))
            else
                self: SetCamDistanceScale(1)
                self: SetPortraitZoom(0.9)
                self: SetPosition(0,0,-0.05)
                self: SetRotation(rad(0))
            end
        end
        

        --[[
        --self: SetUnit("player")
        --self: SetModel("Character\\NightElf\\Female\\NightElfFemale.mdx")
        --self: SetCustomRace(RaceID, Gender) Gender: 0 Male, 1 Female
        self: SetCustomRace(6, 1)
        local fileID = self:GetModelFileID()
        print("fileID", fileID)
        if fileID and RaceModelFileList[fileID] then
            self: SetCamDistanceScale(RaceModelFileList[fileID][1])
		    self: SetPortraitZoom(RaceModelFileList[fileID][2])
		    self: SetPosition(RaceModelFileList[fileID][3],RaceModelFileList[fileID][4],RaceModelFileList[fileID][5])
		    self: SetRotation(rad(RaceModelFileList[fileID][6]))
        else
            local RaceID = select(3,UnitRace("player"))
            local Gender = UnitSex("player")
            RaceID = 6
            Gender = 3
                --1 = Neutrum / Unknown
                --2 = Male
                --3 = Female
            if RaceModelList[RaceID] and RaceModelList[RaceID][Gender] then
                self: SetCamDistanceScale(RaceModelList[RaceID][Gender][1])
                self: SetPortraitZoom(RaceModelList[RaceID][Gender][2])
                self: SetPosition(RaceModelList[RaceID][Gender][3],RaceModelList[RaceID][Gender][4],RaceModelList[RaceID][Gender][5])
                self: SetRotation(rad(RaceModelList[RaceID][Gender][6]))
            else
                self: SetCamDistanceScale(1)
                self: SetPortraitZoom(0.9)
                self: SetPosition(0,0,-0.05)
                self: SetRotation(rad(0))
            end
        end
        --]]
    end)

    return Model
end

local function Badge_Template(frame)
    local Badge = CreateFrame("Frame", nil, frame)
    Badge: SetSize(34,42)
    Badge: SetFrameLevel(frame:GetFrameLevel()+4)
    
    local Bg = Badge: CreateTexture(nil, "BACKGROUND")
    Bg: SetTexture(OW.Path("Player_Bd2"))
    Bg: SetSize(34,42)
    Bg: SetTexCoord(141/256,209/256, 1/128,85/128)
    Bg: SetVertexColor(F.Color(C.Color.Alliance[2]))
    Bg: SetPoint("CENTER")
    Bg: SetAlpha(1)

    local Bd = Badge: CreateTexture(nil, "ARTWORK")
    Bd: SetTexture(OW.Path("Player_Bd2"))
    Bd: SetSize(34,42)
    Bd: SetTexCoord(1/256,69/256, 1/128,85/128)
    Bd: SetVertexColor(243/255, 244/255, 246/255)
    Bd: SetPoint("CENTER")
    Bd: SetAlpha(1)

    local BdSd = Badge: CreateTexture(nil, "BACKGROUND")
    BdSd: SetTexture(OW.Path("Player_Bd2"))
    BdSd: SetSize(34,42)
    BdSd: SetTexCoord(71/256,139/256, 1/128,85/128)
    BdSd: SetVertexColor(F.Color(C.Color.Main0))
    BdSd: SetPoint("CENTER")
    BdSd: SetAlpha(0.4)

    local Icon = Badge: CreateTexture(nil, "ARTWORK")
    Icon: SetTexture(OW.Path("Player_Bd3"))
    Icon: SetSize(24,30)
    Icon: SetTexCoord(1/128,49/128, 1/128,61/128)
    Icon: SetVertexColor(243/255, 244/255, 246/255)
    Icon: SetPoint("CENTER")
    Icon: SetAlpha(1)

    local IconSd = Badge: CreateTexture(nil, "BORDER")
    IconSd: SetTexture(OW.Path("Player_Bd3"))
    IconSd: SetSize(24,30)
    IconSd: SetTexCoord(51/128,99/128, 1/128,61/128)
    IconSd: SetVertexColor(F.Color(C.Color.Main0))
    IconSd: SetPoint("CENTER")
    IconSd: SetAlpha(0.4)

    Badge.Bg = Bg
    Badge.Icon = Icon
    Badge.IconSd = IconSd

    return Badge
end

local function PVP_Flag_Update(frame, factionGroup)
    if factionGroup == "Alliance" then
        frame.Badge.Icon: SetTexCoord(1/128,49/128, 1/128,61/128)
        frame.Badge.IconSd: SetTexCoord(51/128,99/128, 1/128,61/128)
        frame.Badge.Bg: SetVertexColor(F.Color(C.Color.Alliance[2]))
    elseif factionGroup == "Horde" then
        frame.Badge.Icon: SetTexCoord(1/128,49/128, 63/128,123/128)
        frame.Badge.IconSd: SetTexCoord(51/128,99/128, 63/128,123/128)
        frame.Badge.Bg: SetVertexColor(F.Color(C.Color.Horde[2]))
    else
        frame.Badge.Icon: SetTexCoord(127/128,128/128, 127/128,128/128)
        frame.Badge.IconSd: SetTexCoord(127/128,128/128, 127/128,128/128)
    end
end

local function Player_Frame(frame)
    local Portrait = CreateFrame("Button", nil, frame, "SecureUnitButtonTemplate")
    Portrait: SetSize(156,170)
    Portrait: SetPoint("BOTTOMLEFT")
    Portrait.Unit = "player"
    Unit_Init(Portrait)

    local Portrait_Bd = Portrait_Artwork(Portrait)
    local Portrait_Model = Portrait_Model(Portrait)
    local Badge = Badge_Template(frame)
    Badge: SetPoint("TOP", Portrait_Model, "BOTTOM", 0,10)

    local HP = CreateFrame("Frame", nil, frame)
    HP: SetFrameLevel(Portrait:GetFrameLevel()+2)
    HP: SetSize(226,45)
    HP: SetPoint("BOTTOMLEFT", Portrait, "BOTTOMRIGHT", -6,50)

    local HP_Bar = HpBar_Template(HP)
    HpBar_Update(HP_Bar, 1)

    local Absorb = Absorb_Template(HP)
    Absorb: SetPoint("CENTER", HP, "CENTER", 1,0)

    local PP = CreateFrame("Frame", nil, frame)
    PP: SetSize(197,22)
    PP: SetPoint("BOTTOMLEFT", Portrait, "BOTTOMRIGHT", 20,34)

    local PP_Bar = PpBar_Template(PP)
    PpBar_Update(PP_Bar, 1)

    local Nums = LeftNum_Template(frame)
    Nums: SetPoint("BOTTOMLEFT", HP, "TOPLEFT", 8,-10)
    LeftNum_HpUpdate(Nums, 2040000)
    LeftNum_PpUpdate(Nums, 2040000)

    frame.HP = HP
    frame.HP.Bar1 = HP_Bar
    frame.HP.Absorb = Absorb
    frame.PP = PP
    frame.PP.Bar1 = PP_Bar
    frame.Portrait = Portrait
    frame.Portrait.Model = Portrait_Model
    frame.PortraitBorder = Portrait_Bd
    frame.Nums = Nums
    frame.Badge = Badge
end

local function PlayerFrame_RgEvent(frame)
    frame: RegisterEvent("PLAYER_ENTERING_WORLD")
	frame: RegisterUnitEvent("UNIT_FACTION", "player")
    frame: RegisterEvent("PLAYER_REGEN_DISABLED")
    frame: RegisterEvent("PLAYER_REGEN_ENABLED")
    frame: RegisterEvent("PLAYER_UPDATE_RESTING")
end

local function PlayerFrame_OnEvent(frame, event, ...)
    if event == "PLAYER_ENTERING_WORLD" or event == "UNIT_FACTION" then
        local ispvp = UnitIsPVP("player");
        if ispvp then
            local factionGroup = UnitFactionGroup("player")
            PVP_Flag_Update(frame, factionGroup)
        end
        frame.Badge: SetShown(ispvp)
    end
    Portrait_StatusUpdate(frame, event)
end

local function PlayerFrame_SetEvent(frame)
    frame: SetScript("OnEvent", PlayerFrame_OnEvent)
end

----------------------------------------------------------------
--> Pet
----------------------------------------------------------------

local function Pet_HpBar_Template(frame)
    local HpBar = CreateFrame("Frame", nil, frame)
    HpBar: SetSize(24,18)

    local Bar = HpBar: CreateTexture(nil, "ARTWORK")
    Bar: SetVertexColor(243/255, 244/255, 246/255)
    Bar: SetAlpha(1)
    Bar: SetTexture(OW.Path("Bar4_1"))
    Bar: SetPoint("CENTER")
    Bar: SetSize(24,18)
    Bar: SetTexCoord(0/64,48/64, 1/512,37/512)

    local Bg = HpBar: CreateTexture(nil, "BORDER")
    Bg: SetVertexColor(243/255, 244/255, 246/255)
    Bg: SetAlpha(0.4)
    Bg: SetTexture(OW.Path("Bar4_1"))
    Bg: SetPoint("CENTER")
    Bg: SetSize(24,18)
    Bg: SetTexCoord(0/64,48/64, 1/512,37/512)

    local Sd = HpBar: CreateTexture(nil, "BACKGROUND")
    Sd: SetVertexColor(F.Color(C.Color.Main0))
    Sd: SetAlpha(0.4)
    Sd: SetTexture(OW.Path("Bar4_1"))
    Sd: SetPoint("CENTER")
    Sd: SetSize(24,18)
    Sd: SetTexCoord(0/64,48/64, 419/512,455/512)

    HpBar.Bar = Bar
    HpBar.Bg = Bg
    HpBar.Sd = Sd

    return HpBar
end

local function Pet_HpBar_Update(frame, d)
    if not d then d = 0 end
    if d < 0 then d = 0 end
    if d > 1 then d = 1 end
    if not frame.OldPer or frame.OldPer ~= d then
        local y1 = 38*floor(11*(1-min(d,0.5)*2)+0.5)
        local y2 = 38*floor(11*(1-max(d-0.5,0)*2)+0.5)
        frame.Bar1.Bar: SetTexCoord(0/64,48/64, (y1+1)/512,(y1+37)/512)
        frame.Bar2.Bar: SetTexCoord(0/64,48/64, (y2+1)/512,(y2+37)/512)
        frame.OldPer = d
    end
end

local function Pet_Frame(frame)
    local PetFrame = CreateFrame("Button", "Quafe_Overwatch.PetFrame", frame, "SecureUnitButtonTemplate")
    PetFrame: SetSize(36+46,36)
    PetFrame: SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT", 292,108)
    PetFrame.Unit = "pet"
    Unit_Init(PetFrame)

    local Portrait = CreateFrame("Frame", nil, PetFrame)
    Portrait: SetSize(36,36)
    Portrait: SetPoint("BOTTOMLEFT")

    local Icon = Portrait:CreateTexture(nil, "ARTWORK")
    Icon: SetTexture(OW.Path("Pet_Bd1"))
    Icon: SetTexCoord(75/256,147/256, 1/256,73/256)
    Icon: SetSize(36,36)
    Icon: SetPoint("CENTER")
    Icon: SetVertexColor(243/255, 244/255, 246/255)

    local IconSd = Portrait:CreateTexture(nil, "BACKGROUND")
    IconSd: SetTexture(OW.Path("Pet_Bd1"))
    IconSd: SetTexCoord(1/256,73/256, 1/256,73/256)
    IconSd: SetSize(36,36)
    IconSd: SetPoint("CENTER")
    IconSd: SetAlpha(0.4)
    IconSd: SetVertexColor(F.Color(C.Color.Main0))

    local HP = CreateFrame("Frame", nil, PetFrame)
    HP: SetFrameLevel(Portrait:GetFrameLevel()+2)
    HP: SetSize(24,18)
    HP: SetPoint("BOTTOMLEFT", Portrait, "BOTTOMLEFT", 43,1)

    local HP_Bar1 = Pet_HpBar_Template(HP)
    HP_Bar1: SetPoint("BOTTOMLEFT", HP, "BOTTOMLEFT", 0,2)
    local HP_Bar2 = Pet_HpBar_Template(HP)
    HP_Bar2: SetPoint("BOTTOMLEFT", HP_Bar1, "BOTTOMLEFT", 21,2)
    HP.Bar1 = HP_Bar1
    HP.Bar2 = HP_Bar2
    Pet_HpBar_Update(HP, 1)

    frame.PetFrame = PetFrame
    frame.PetFrame.HP = HP
    frame.PetFrame.Portrait = Portrait
    frame.PetFrame.Portrait.Icon = Icon
end

local function SetHappiness(frame)
    if not F.IsClassic then return end
	local happiness, damagePercentage, loyaltyRate = GetPetHappiness();
	--> 1 = unhappy, 2 = content, 3 = happy
	local hasPetUI, isHunterPet = HasPetUI();

	if ( not happiness or not isHunterPet ) then
        frame.Portrait.Icon: SetVertexColor(243/255, 244/255, 246/255)
		frame.tooltip = nil
		return;	
	end

	if ( happiness == 1 ) then
        frame.Portrait.Icon: SetVertexColor(F.Color(C.Color.Warn1))
	elseif ( happiness == 2 ) then
        frame.Portrait.Icon: SetVertexColor(F.Color(C.Color.Main2))
	elseif ( happiness == 3 ) then
        frame.Portrait.Icon: SetVertexColor(243/255, 244/255, 246/255)
	end

	frame.tooltip = _G["PET_HAPPINESS"..happiness];
	frame.tooltipDamage = format(PET_DAMAGE_PERCENTAGE, damagePercentage);
	if ( loyaltyRate < 0 ) then
		frame.tooltipLoyalty = _G["LOSING_LOYALTY"];
	elseif ( loyaltyRate > 0 ) then
		frame.tooltipLoyalty = _G["GAINING_LOYALTY"];
	else
		frame.tooltipLoyalty = nil;
	end
end

local function Happiness_OnEnter(frame)
    if F.IsClassic then
        frame: HookScript("OnEnter", function(self)
            if ( self.tooltip ) then
                GameTooltip:AddLine(" ")
                GameTooltip:AddLine(self.tooltip);
                if ( self.tooltipDamage ) then
                    GameTooltip:AddLine(self.tooltipDamage, "", 1, 1, 1);
                end
                if ( self.tooltipLoyalty ) then
                    GameTooltip:AddLine(self.tooltipLoyalty, "", 1, 1, 1);
                end
            end
            GameTooltip:Show()
        end)
    end
end

local function PetFrame_RgEvent(frame)
    if F.IsClassic then
        frame: RegisterEvent("PLAYER_ENTERING_WORLD")
        frame: RegisterUnitEvent("UNIT_PET", "player")
        frame: RegisterEvent("PET_UI_UPDATE")
        frame: RegisterEvent("UNIT_HAPPINESS")
    end
end

local function PetFrame_SetEvent(frame)
    if F.IsClassic then
        frame: SetScript("OnEvent", SetHappiness)
    end
end

----------------------------------------------------------------
--> Load
----------------------------------------------------------------

local OW_PlayerFrame = CreateFrame("Frame", "Quafe_Overwatch.PlayerFrame", E)
OW_PlayerFrame: SetSize(156,170)
OW_PlayerFrame: SetFrameStrata("LOW")
OW_PlayerFrame.Init = false

local function OW_PlayerFrame_HpUpdate(arg1,arg2,arg3)
    if arg1 == "Update" then
        HpBar_Update(OW_PlayerFrame.HP.Bar1, arg2)
    elseif arg1 == "Event" then
        LeftNum_HpUpdate(OW_PlayerFrame.Nums, arg3)
    end
end

local function OW_PlayerFrame_PpUpdate(arg1,arg2,arg3)
    if arg1 == "Update" then
        --PpBar_Update(OW_PlayerFrame.PP.Bar1, arg2.Cur)
        PpBar_Update(OW_PlayerFrame.PP.Bar1, arg2)
    elseif arg1 == "Event" then
        --LeftNum_PpUpdate(OW_PlayerFrame.Nums, arg2.Min)
        LeftNum_PpUpdate(OW_PlayerFrame.Nums, arg3)
    end
end

local function OW_PlayerFrame_AsUpdate(arg1,arg2)
    if arg1 == "Update" then
        --Absorb_Update(OW_PlayerFrame.HP.Absorb, arg2.Cur)
        Absorb_Update(OW_PlayerFrame.HP.Absorb, arg2)
    end
end

local function OW_PlayerFrame_MnUpdate(arg1,arg2)
    if arg1 == "Update" then
        --PpBar_ManaUpdate(OW_PlayerFrame.PP.Bar1, arg2.Cur)
        PpBar_ManaUpdate(OW_PlayerFrame.PP.Bar1, arg2)
    end
end

local function OW_PetFrame_HpUpdate(arg1,arg2,arg3)
    if arg1 == "Update" then
        --Pet_HpBar_Update(OW_PlayerFrame.PetFrame.HP, arg2.Cur)
        Pet_HpBar_Update(OW_PlayerFrame.PetFrame.HP, arg2)
    elseif arg1 == "Event" then
       
    end
end

local function Joystick_Update(self, elapsed)
	local x2 = Quafe_DB.Profile[Quafe_DBP.Profile].OW_PlayerFrame.PosX
	local y2 = Quafe_DB.Profile[Quafe_DBP.Profile].OW_PlayerFrame.PosY
	local x0,y0 = OW_PlayerFrame: GetCenter()
	local x1,y1 = self: GetCenter()
	local step = floor(1/(GetFramerate())*1e3)/1e3
	if x0 ~= x1 then
		x2 = x2 + (x1-x0)*step/2
	end
	if y0 ~= y1 then
		y2 = y2 + (y1-y0)*step/2
	end
	OW_PlayerFrame: SetPoint("BOTTOMLEFT", UIParent, "BOTTOMLEFT", x2,y2)
	Quafe_DB.Profile[Quafe_DBP.Profile].OW_PlayerFrame.PosX = x2
	Quafe_DB.Profile[Quafe_DBP.Profile].OW_PlayerFrame.PosY = y2
    F.OW_MinimapFrame_Pos(x2,y2)
end

local function OW_PlayerFrame_Load()
    if Quafe_DB.Profile[Quafe_DBP.Profile].OW_PlayerFrame.Enable then
        OW_PlayerFrame: SetPoint("BOTTOMLEFT", UIParent, "BOTTOMLEFT", Quafe_DB.Profile[Quafe_DBP.Profile].OW_PlayerFrame.PosX,Quafe_DB.Profile[Quafe_DBP.Profile].OW_PlayerFrame.PosY)
        F.CreateJoystick(OW_PlayerFrame, 156,170, "Quafe_Overwatch "..L['PLAYER_FRAME'])
		OW_PlayerFrame.Joystick.postUpdate = Joystick_Update
        
        Player_Frame(OW_PlayerFrame)
        PlayerFrame_RgEvent(OW_PlayerFrame)
        PlayerFrame_SetEvent(OW_PlayerFrame)
        tinsert(E.UBU.Player.HP, OW_PlayerFrame_HpUpdate)
        tinsert(E.UBU.Player.PP, OW_PlayerFrame_PpUpdate)
        tinsert(E.UBU.Player.AS, OW_PlayerFrame_AsUpdate)
        tinsert(E.UBU.Player.MN, OW_PlayerFrame_MnUpdate)

        Pet_Frame(OW_PlayerFrame)
        PetFrame_RgEvent(OW_PlayerFrame.PetFrame)
        PetFrame_SetEvent(OW_PlayerFrame.PetFrame)
        Happiness_OnEnter(OW_PlayerFrame.PetFrame)
        tinsert(E.UBU.Pet.HP, OW_PetFrame_HpUpdate)

        if Quafe_DB.Profile[Quafe_DBP.Profile].OW_PlayerFrame.Scale then
			OW_PlayerFrame: SetScale(Quafe_DB.Profile[Quafe_DBP.Profile].OW_PlayerFrame.Scale)
		end

        OW_PlayerFrame.Init = true
    end
end

local function OW_PlayerFrame_Toggle(arg)
    if arg == "ON" then
		if not OW_PlayerFrame.Init then
			OW_PlayerFrame_Load()
		end
        if not OW_PlayerFrame:IsShown() then
			OW_PlayerFrame: Show()
		end
        PlayerFrame_OnEvent(OW_PlayerFrame, "PLAYER_ENTERING_WORLD")
        F.UBGU_ForceUpdate()
	elseif arg == "OFF" then
		OW_PlayerFrame: Hide()
		Quafe_NoticeReload()
	elseif type(arg) == "number" then
		OW_PlayerFrame: SetScale(arg)
        Portrait_UpdateScale(OW_PlayerFrame.Portrait.Model)
	end
end

local OW_PlayerFrame_Config = {
	Database = {
		["OW_PlayerFrame"] = {
			["Enable"] = true,
			["PosX"] = 100,
			["PosY"] = 60,
			Scale = 1,
		},
	},

    Config = {
        Name = "Overwatch "..L['PLAYER_FRAME'],
        Type = "Switch",
        Click = function(self, button)
			if InCombatLockdown() then return end
			if Quafe_DB.Profile[Quafe_DBP.Profile].OW_PlayerFrame.Enable then
				Quafe_DB.Profile[Quafe_DBP.Profile].OW_PlayerFrame.Enable = false
				self.Text:SetText(L["OFF"])
				OW_PlayerFrame_Toggle("OFF")
			else
				Quafe_DB.Profile[Quafe_DBP.Profile].OW_PlayerFrame.Enable = true
				self.Text:SetText(L["ON"])
				OW_PlayerFrame_Toggle("ON")
			end
		end,
		Show = function(self)
			if Quafe_DB.Profile[Quafe_DBP.Profile].OW_PlayerFrame.Enable then
				self.Text:SetText(L["ON"])
			else
				self.Text:SetText(L["OFF"])
			end
		end,
        Sub = {
			[1] = {
                Name = L['SCALE'],
                Type = "Slider",
                State = "ALL",
				Click = nil,
                Load = function(self)
                    self.Slider: SetMinMaxValues(0.5, 2)
					self.Slider: SetValueStep(0.05)
                    self.Slider: SetValue(Quafe_DB.Profile[Quafe_DBP.Profile].OW_PlayerFrame.Scale)
					self.Slider: HookScript("OnValueChanged", function(s, value)
                        value = floor(value*100+0.5)/100
                        Quafe_DB.Profile[Quafe_DBP.Profile].OW_PlayerFrame.Scale = value
						OW_PlayerFrame_Toggle(value)
					end)
                end,
                Show = nil,
            },
		},
    },
}

OW_PlayerFrame.Load = OW_PlayerFrame_Load
OW_PlayerFrame.Config = OW_PlayerFrame_Config
tinsert(E.Module, OW_PlayerFrame)